﻿Type=Class
Version=5.5
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private JO As JavaObject
	Private RecognizerIntent As Intent
	Private Initialized As Boolean
	
	Private Label1 As Label
	Private ProgressBar1 As ProgressBar
	Private ToggleButton1 As ToggleButton
	Private SpeechRecognizer As JavaObject
	Private Button1 As Button
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(Act As Activity)
	
	Act.LoadLayout("1")
	
	SpeechRecognizer.InitializeStatic("android.speech.SpeechRecognizer")
	JO = SpeechRecognizer.RunMethod("createSpeechRecognizer",Array(JO.InitializeContext))
	
	If Not(IsRecognitionAvailable) Then
		Log("Speech Recognition Not Available")
		Label1.Text = "Speech Recognition Not Available"
		Return
	End If
	
	RecognizerIntent.Initialize("android.speech.action.RECOGNIZE_SPEECH",Null)
	RecognizerIntent.PutExtra("android.speech.extra.LANGUAGE_PREFERENCE","en")
	RecognizerIntent.PutExtra("calling_package",Application.PackageName)
	RecognizerIntent.PutExtra("android.speech.extra.LANGUAGE_MODEL","web_search")
	RecognizerIntent.PutExtra("android.speech.extra.MAX_RESULTS",3)
	
	Dim Event As Object = JO.CreateEvent("android.speech.RecognitionListener","Received","")
	JO.RunMethod("setRecognitionListener",Array(Event))
	Initialized = True
End Sub

Public Sub IsInitialized As Boolean
	Return Initialized
End Sub


Public Sub IsRecognitionAvailable As Boolean
	Dim JO1 As JavaObject
	JO1.InitializeContext
	Return JO.RunMethod("isRecognitionAvailable",Array(JO1))
End Sub
Public Sub StartListening
	JO.RunMethod("startListening",Array(RecognizerIntent))
End Sub
Public Sub StopListening
	JO.RunMethod("stopListening",Null)
End Sub

Public Sub Destroy
	JO.RunMethod("destroy",Null)
End Sub

Private Sub Received_Event (MethodName As String, Args() As Object) As Object
	Select MethodName
		Case "onBeginningOfSpeech"
			ProgressBar1.Indeterminate = False
		Case "onEndOfSpeech"
			ProgressBar1.Indeterminate = True
			ToggleButton1.Checked = False
		Case "onError"
			Dim ErrorMsg As String = GetErrorText(Args(0))
			Log("Failed " & ErrorMsg)
			Label1.Text = ErrorMsg
			ToggleButton1.Checked = False
		Case "onResults"
			Dim Results As JavaObject = Args(0)
			Dim Matches As List = Results.RunMethod("getStringArrayList",Array("results_recognition"))
			Log(Matches.Size)
			Dim Text As String = ""
			For Each Result As String In Matches
				Text = Text & Result & CRLF
			Next
			Log(Text)
			Label1.Text = Text
		Case "onRmsChanged"
			ProgressBar1.Progress = Args(0) * 10
	End Select
	
End Sub

Sub ToggleButton1_CheckedChange(Checked As Boolean)
	If Checked Then
		ProgressBar1.Visible = True
		ProgressBar1.Indeterminate = True
		StartListening
	Else
		ProgressBar1.Indeterminate = False
		ProgressBar1.Visible = False
		StopListening
	End If
End Sub

Sub GetErrorText(ErrorCode As Int) As String
	Select ErrorCode
		Case SpeechRecognizer.GetField("ERROR_AUDIO")
			Return "Audio Recording error"
		 Case SpeechRecognizer.GetField("ERROR_CLIENT")
 			Return "Client side error"
 		Case SpeechRecognizer.GetField("ERROR_INSUFFICIENT_PERMISSIONS")
			Return "Insufficient permissions"
 		Case SpeechRecognizer.GetField("ERROR_NETWORK")
 			Return "Network error"
 		Case SpeechRecognizer.GetField("ERROR_NETWORK_TIMEOUT")
 			Return "Network timeout"
 		 Case SpeechRecognizer.GetField("ERROR_NO_MATCH")
 			Return "No match"
  		Case SpeechRecognizer.GetField("ERROR_RECOGNIZER_BUSY")
 			Return "RecognitionService busy"
 		 Case SpeechRecognizer.GetField("ERROR_SERVER")
 			Return "error from server"
 		Case SpeechRecognizer.GetField("ERROR_SPEECH_TIMEOUT")
			Return "No speech input"
 		Case Else
 			Return "Didn't understand, please try again."
	End Select
End Sub

Sub Button1_Click
	
End Sub